-- sr2_city.lua
-- Master Lua Script for Saints Row 2
-- 3/28/07


-- Play as a cop variables

-- Thread handles
CallBackupHandle = INVALID_THREAD_HANDLE
RequestVehicleHandle = INVALID_THREAD_HANDLE
USER_INPUT_THREAD_HANDLE = INVALID_THREAD_HANDLE

PLAYER_IS_COP = false -- Is player currently a cop ?
CALL_BACKUP_KEY = 26 -- Key code to call for reinforcements (currently : 26 = horn)
BACKUP_LEVEL_PROMPT_SHOW = false  -- Has the prompt to select reinforcements level already been shown ?
DELIVERY_INSTRUCTIONS_SHOWN = false -- Has the intruction to choose a vehicle already been shown ?
NBPRESS = 0 -- Number of key press for CALL_BACKUP_KEY
POLICE_OUTFIT_NAME = "Police Outfit" -- Outfit to use when going on duty
--CIVILIAN_OUTFIT_NAME = "Street 1"
CIVILIAN_OUTFIT_NAME = "Suit purple man" -- Outfit to use when going off duty
TRIGGER_STARTCOP = "playasacop_$start" -- Trigger to start the mod
TRIGGER_STARTZONE = "playasacop_$zone" -- Trigger for the prompt to start the mod
TRIGGER_VEHICLEREQUEST = "playasacop_vehicle_request" -- Trigger for the vehicle delivery
TRIGGER_VEHICLE_REQUEST_ZONE = "playasacop_vehicle_request_zone"

-- Triggers for Ultor go on/off duty
TRIGGER_START_ULTOR_1 = "playasacop_start_ultor1"
TRIGGER_ZONE_ULTOR_1 = "playasacop_zone_ultor1"
TRIGGER_START_ULTOR_2 = "playasacop_start_ultor2"
TRIGGER_ZONE_ULTOR_2 = "playasacop_zone_ultor2"
TRIGGER_START_ULTOR_3 = "playasacop_start_ultor3"
TRIGGER_ZONE_ULTOR_3 = "playasacop_zone_ultor3"
TRIGGER_START_ULTOR_4 = "playasacop_start_ultor4"
TRIGGER_ZONE_ULTOR_4 = "playasacop_zone_ultor4"

-- Triggers for Ultor vehicle delivery
TRIGGER_VEHICLEREQUEST_ULTOR1 = "playasacop_vehicle_request_ultor1"
TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR1 = "playasacop_vehicle_request_zone_ultor1"
TRIGGER_VEHICLEREQUEST_ULTOR2 = "playasacop_vehicle_request_ultor2"
TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR2 = "playasacop_vehicle_request_zone_ultor2"


-- Vehicles to deliver
COPCAR_GROUP = "playasacop_delivery_copcar"
COPCAR_VEHICLE = "playasacop_copcar"
COPAPC_GROUP = "playasacop_delivery_apc"
COPAPC_VEHICLE = "playasacop_apc"
METERMAID_GROUP = "playasacop_delivery_metermaid"
METERMAID_VEHICLE = "playasacop_metermaid"
FBISUV_GROUP = "playasacop_delivery_fbi"
FBISUV_VEHICLE = "playasacop_fbi"
POLICEBIKE_GROUP = "playasacop_delivery_bike"
POLICEBIKE_VEHICLE = "playasacop_bike"
SWATTRUCK_GROUP = "playasacop_delivery_swat"
SWATTRUCK_VEHICLE = "playasacop_swat"

-- Ultor cars to deliver
-- Location 1
ULTOR1_COPCAR_GROUP = "playasacop_delivery_copcar_ultor1"
ULTOR1_COPCAR_VEHICLE = "playasacop_copcar_ultor1"
ULTOR1_APC_GROUP = "playasacop_delivery_apc_ultor1"
ULTOR1_APC_VEHICLE = "playasacop_apc_ultor1"
ULTOR1_NUKE_GROUP = "playasacop_delivery_nukecar_ultor1"
ULTOR1_NUKE_VEHICLE = "playasacop_nukecar_ultor1"
ULTOR1_SUV_GROUP = "playasacop_delivery_fbi_ultor1"
ULTOR1_SUV_VEHICLE = "playasacop_fbi_ultor1"
ULTOR1_SWAT_GROUP = "playasacop_delivery_swat_ultor1"
ULTOR1_SWAT_VEHICLE = "playasacop_swat_ultor1"
-- Location 2
ULTOR2_COPCAR_GROUP = "playasacop_delivery_copcar_ultor2"
ULTOR2_COPCAR_VEHICLE = "playasacop_copcar_ultor2"
ULTOR2_APC_GROUP = "playasacop_delivery_apc_ultor2"
ULTOR2_APC_VEHICLE = "playasacop_apc_ultor2"
ULTOR2_NUKE_GROUP = "playasacop_delivery_nukecar_ultor2"
ULTOR2_NUKE_VEHICLE = "playasacop_nukecar_ultor2"
ULTOR2_SUV_GROUP = "playasacop_delivery_fbi_ultor2"
ULTOR2_SUV_VEHICLE = "playasacop_fbi_ultor2"
ULTOR2_SWAT_GROUP = "playasacop_delivery_swat_ultor2"
ULTOR2_SWAT_VEHICLE = "playasacop_swat_ultor2"

VEHICLE_SPAWN_WANTS_INPUT = false
ULTOR1_VEHICLE_SPAWN_WANTS_INPUT = false
ULTOR2_VEHICLE_SPAWN_WANTS_INPUT = false
HELI_SPAWN_WANTS_INPUT = false
BOAT_SPAWN_WANTS_INPUT = false
CALL_BACKUP_WANTS_INPUT = false
PLAYASACOP_DEBUG = false

-- Vanilla includes

include("airport.lua")					-- DISTRICTS
include("apartments.lua")
include("arena.lua")
include("barrio.lua")
include("chinatown.lua")
include("docks.lua")
include("downtown.lua")
include("factories.lua")
include("highend.lua")
include("hotels.lua")
include("museum.lua")
include("nuke.lua")
include("prison.lua")
include("projects.lua")
include("redlight.lua")
include("saintsrow.lua")
include("suburbs.lua")
include("subexp.lua")
include("trailerpark.lua")
include("truckyard.lua")
include("ultor_base.lua")
include("underground.lua")
include("university.lua")

include("mission_globals.lua")		-- MISSIONS
include("stronghold_globals.lua")	-- STRONGHOLDS

-- Play as a cop functions

function txtprint(text)
	objective_text_clear(0)
	mission_help_table(text, LOCAL_PLAYER)
end

function police_vehicle_delivery(GROUP,CAR)
		group_create(GROUP)
		group_show(GROUP)
		VEHICLE_SPAWN_WANTS_INPUT = false
		ULTOR1_VEHICLE_SPAWN_WANTS_INPUT = false
		ULTOR2_VEHICLE_SPAWN_WANTS_INPUT = false
		vehicle_enter_teleport(LOCAL_PLAYER,CAR)
		release_to_world(GROUP)
		mission_help_clear(SYNC_LOCAL)
end

function read_user_input()
	NBPRESS = 0
	while(true) do
		-- Read car to spawn
		if ULTOR1_VEHICLE_SPAWN_WANTS_INPUT and PLAYER_IS_COP then
			if player_button_just_pressed(39) then
				police_vehicle_delivery(ULTOR1_COPCAR_GROUP,ULTOR1_COPCAR_VEHICLE)
			elseif player_button_just_pressed(40) then
				police_vehicle_delivery(ULTOR1_APC_GROUP,ULTOR1_APC_VEHICLE)
			elseif player_button_just_pressed(41) then
				police_vehicle_delivery(ULTOR1_NUKE_GROUP,ULTOR1_NUKE_VEHICLE)
			elseif player_button_just_pressed(42) then
				police_vehicle_delivery(ULTOR1_SUV_GROUP,ULTOR1_SUV_VEHICLE)
			elseif player_button_just_pressed(43) then
				police_vehicle_delivery(ULTOR1_SWAT_GROUP,ULTOR1_SWAT_VEHICLE)
			elseif player_button_just_pressed(0) or player_button_just_pressed(1) or player_button_just_pressed(2) or player_button_just_pressed(3) or player_button_just_pressed(4) or player_button_just_pressed(37) or player_button_just_pressed(38) or player_button_just_pressed(52) or player_button_just_pressed(53) or player_button_just_pressed(57) then -- 0 to 3 are directionnal key, 4 is action, 37 accelerate, 38 reverse, 57 nitro, 52 recruit, 53 dismiss
				txtprint("Wrong input, vehicle delivery aborted")
			end
			
		elseif ULTOR2_VEHICLE_SPAWN_WANTS_INPUT and PLAYER_IS_COP then
			if player_button_just_pressed(39) then
				police_vehicle_delivery(ULTOR2_COPCAR_GROUP,ULTOR2_COPCAR_VEHICLE)
			elseif player_button_just_pressed(40) then
				police_vehicle_delivery(ULTOR2_APC_GROUP,ULTOR2_APC_VEHICLE)
			elseif player_button_just_pressed(41) then
				police_vehicle_delivery(ULTOR2_NUKE_GROUP,ULTOR1_NUKE_VEHICLE)
			elseif player_button_just_pressed(42) then
				police_vehicle_delivery(ULTOR2_SUV_GROUP,ULTOR2_SUV_VEHICLE)
			elseif player_button_just_pressed(43) then
				police_vehicle_delivery(ULTOR2_SWAT_GROUP,ULTOR2_SWAT_VEHICLE)
			elseif player_button_just_pressed(0) or player_button_just_pressed(1) or player_button_just_pressed(2) or player_button_just_pressed(3) or player_button_just_pressed(4) or player_button_just_pressed(37) or player_button_just_pressed(38) or player_button_just_pressed(52) or player_button_just_pressed(53) or player_button_just_pressed(57) then -- 0 to 3 are directionnal key, 4 is action, 37 accelerate, 38 reverse, 57 nitro, 52 recruit, 53 dismiss
				txtprint("Wrong input, vehicle delivery aborted")
			end
			
		elseif VEHICLE_SPAWN_WANTS_INPUT and PLAYER_IS_COP then
			if player_button_just_pressed(39) then
				police_vehicle_delivery(COPCAR_GROUP,COPCAR_VEHICLE)
			elseif player_button_just_pressed(40) then
				police_vehicle_delivery(COPAPC_GROUP,COPAPC_VEHICLE)
			elseif player_button_just_pressed(41) then
				police_vehicle_delivery(METERMAID_GROUP,METERMAID_VEHICLE)
			elseif player_button_just_pressed(42) then
				police_vehicle_delivery(FBISUV_GROUP,FBISUV_VEHICLE)
			elseif player_button_just_pressed(43) then
				police_vehicle_delivery(POLICEBIKE_GROUP,POLICEBIKE_VEHICLE)
			elseif player_button_just_pressed(44) then
				police_vehicle_delivery(SWATTRUCK_GROUP,SWATTRUCK_VEHICLE)
			elseif player_button_just_pressed(0) or player_button_just_pressed(1) or player_button_just_pressed(2) or player_button_just_pressed(3) or player_button_just_pressed(4) or player_button_just_pressed(37) or player_button_just_pressed(38) or player_button_just_pressed(52) or player_button_just_pressed(53) or player_button_just_pressed(57) then -- 0 to 3 are directionnal key, 4 is action, 37 accelerate, 38 reverse, 57 nitro, 52 recruit, 53 dismiss
				txtprint("Wrong input, vehicle delivery aborted")
			end
			
		-- Read heli to spawn
		--elseif HELI_SPAWN_WANTS_INPUT and PLAYER_IS_COP then
			-- TODO
			
		-- Read boat to spawn
		--elseif BOAT_SPAWN_WANTS_INPUT and PLAYER_IS_COP then
			-- TODO
		
		-- Read notoriety level to set
		elseif CALL_BACKUP_WANTS_INPUT and PLAYER_IS_COP then		
			if player_button_just_pressed(39) then
				notoriety_set( "Police", 1 )
				notoriety_set_min( "Police", 1 )
				notoriety_set_max( "Police", 1 )
				txtprint("Reinforcements level 1 called")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			elseif player_button_just_pressed(40) then
				notoriety_set( "Police", 2 )
				notoriety_set_min( "Police", 2 )
				notoriety_set_max( "Police", 2 )
				txtprint("Reinforcements level 2 called")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			elseif player_button_just_pressed(41) then
				notoriety_set( "Police", 3 )
				notoriety_set_min( "Police", 3 )
				notoriety_set_max( "Police", 3 )
				txtprint("Reinforcements level 3 called")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			elseif player_button_just_pressed(42) then
				notoriety_set( "Police", 4 )
				notoriety_set_min( "Police", 4 )
				notoriety_set_max( "Police", 4 )
				txtprint("Reinforcements level 4 called")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			elseif player_button_just_pressed(43) then
				notoriety_set( "Police", 5 )
				notoriety_set_min( "Police", 5 )
				notoriety_set_max( "Police", 5 )
				txtprint("Reinforcements level 5 called")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			elseif player_button_just_pressed(46) then
				notoriety_set( "Police", 0 )
				notoriety_set_min( "Police", 0 )
				notoriety_set_max( "Police", 0 )
				txtprint("Reinforcements dismissed")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			elseif player_button_just_pressed(0) or player_button_just_pressed(1) or player_button_just_pressed(2) or player_button_just_pressed(3) or player_button_just_pressed(4) or player_button_just_pressed(37) or player_button_just_pressed(38) or player_button_just_pressed(52) or player_button_just_pressed(53) or player_button_just_pressed(57) then -- 0 to 3 are directionnal key, 4 is action, 37 accelerate, 38 reverse, 57 nitro, 52 recruit, 53 dismiss
				txtprint("Wrong input, call aborted")
				NBPRESS = 0
				CALL_BACKUP_WANTS_INPUT = false
			end

		-- Listen for CALL_BACKUP_KEY
		elseif PLAYER_IS_COP then
			if player_button_just_pressed(CALL_BACKUP_KEY) and NBPRESS < 2 then
				NBPRESS = NBPRESS + 1
				txtprint("Press H again to call for reinforcements")
			end
			if NBPRESS == 2 then
				txtprint("Press 1 - 5 for the selected reinforcements level (8 to cancel)")
				CALL_BACKUP_WANTS_INPUT = true
			end
			
		-- Listen for CALL_BACKUP_KEY (debug mode : warps to police station)
		elseif not PLAYER_IS_COP and PLAYASACOP_DEBUG then
			if player_button_just_pressed(CALL_BACKUP_KEY) and NBPRESS < 2 then
				NBPRESS = NBPRESS + 1
				txtprint("Press H again to warp to Saints Row district")
			end
			if NBPRESS == 2 then
				teleport("#PLAYER#", "playasacop_vehicle_delivery")
				NBPRESS = 0
			end
		end
		thread_yield()
	end
end

function request_vehicle(triggerer,trigger)
	if trigger == TRIGGER_VEHICLEREQUEST then
		txtprint("Press:\n1 for police car\n2 for APC\n3 for parking enforcement cart\n4 for FBI SUV\n5 for police bike\n6 for SWAT truck")
		VEHICLE_SPAWN_WANTS_INPUT = true
		ULTOR1_VEHICLE_SPAWN_WANTS_INPUT = false
		ULTOR2_VEHICLE_SPAWN_WANTS_INPUT = false
	elseif trigger == TRIGGER_VEHICLEREQUEST_ULTOR1 then
		txtprint("Press:\n1 for Ultor police car\n2 for Ultor APC\n3 for nuke plant security car\n4 for Ultor SUV\n5 for Ultor SWAT truck")
		ULTOR1_VEHICLE_SPAWN_WANTS_INPUT = true
		ULTOR2_VEHICLE_SPAWN_WANTS_INPUT = false
		VEHICLE_SPAWN_WANTS_INPUT = false
	elseif trigger == TRIGGER_VEHICLEREQUEST_ULTOR2 then	
		txtprint("Press:\n1 for Ultor police car\n2 for Ultor APC\n3 for nuke plant security car\n4 for Ultor SUV\n5 for Ultor SWAT truck")
		ULTOR1_VEHICLE_SPAWN_WANTS_INPUT = false
		ULTOR2_VEHICLE_SPAWN_WANTS_INPUT = true
		VEHICLE_SPAWN_WANTS_INPUT = false
	end

end

function enter_startcopzone(triggerer,trigger)
	if PLAYER_IS_COP then
		txtprint("Press E to go OFF duty (reverts to Saints team)")
	else
		txtprint("Press E to go ON duty (switch to Police team)")
	end
end

function enter_request_vehicle_zone(triggerer,trigger)
	if PLAYER_IS_COP then
		txtprint("Press E to request a vehicle")
	end
end

function switch_teams(triggerer,trigger)
	if PLAYER_IS_COP then
		txtprint("Going OFF duty (reverts back to Saints team)")
		set_team( LOCAL_PLAYER , "Playas")
		PLAYER_IS_COP = false
		notoriety_set_min( "Police", 0 )
		notoriety_set_max( "Police", 5 )
		notoriety_set( "Police", 0 )
		notoriety_reset( "Police", 0 )
		NBPRESS = 0
		--customization_item_revert(SYNC_LOCAL)
		--customization_outfit_wear(CIVILIAN_OUTFIT_NAME, 0, SYNC_LOCAL )
		on_trigger("",TRIGGER_VEHICLEREQUEST)
		on_trigger("",TRIGGER_VEHICLE_REQUEST_ZONE)
		trigger_enable(TRIGGER_VEHICLEREQUEST,false)
		trigger_enable(TRIGGER_VEHICLE_REQUEST_ZONE,false)
		ingame_effect_remove_trigger(TRIGGER_VEHICLEREQUEST)
		on_trigger("",TRIGGER_VEHICLEREQUEST_ULTOR1)
		on_trigger("",TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR1)
		trigger_enable(TRIGGER_VEHICLEREQUEST_ULTOR1,false)
		trigger_enable(TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR1,false)
		ingame_effect_remove_trigger(TRIGGER_VEHICLEREQUEST_ULTOR1)
		on_trigger("",TRIGGER_VEHICLEREQUEST_ULTOR2)
		on_trigger("",TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR2)
		trigger_enable(TRIGGER_VEHICLEREQUEST_ULTOR2,false)
		trigger_enable(TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR2,false)
		ingame_effect_remove_trigger(TRIGGER_VEHICLEREQUEST_ULTOR2)
	else
		txtprint("Going ON duty (switching to Police team)\nPress H twice at any time to call for reinforcements")
		set_team( LOCAL_PLAYER , "Police")
		PLAYER_IS_COP = true
		notoriety_set( "Police", 0 )
		notoriety_set_min( "Police", 0 )
		notoriety_set_max( "Police", 0 )
		NBPRESS = 0
		customization_outfit_wear(POLICE_OUTFIT_NAME, 0, SYNC_LOCAL )
		on_trigger("enter_request_vehicle_zone",TRIGGER_VEHICLE_REQUEST_ZONE)
		on_trigger("request_vehicle",TRIGGER_VEHICLEREQUEST)
		trigger_enable(TRIGGER_VEHICLEREQUEST,true)
		trigger_enable(TRIGGER_VEHICLE_REQUEST_ZONE,true)
		ingame_effect_add_trigger(TRIGGER_VEHICLEREQUEST,INGAME_EFFECT_LOCATION)
		on_trigger("enter_request_vehicle_zone",TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR1)
		on_trigger("request_vehicle",TRIGGER_VEHICLEREQUEST_ULTOR1)
		trigger_enable(TRIGGER_VEHICLEREQUEST_ULTOR1,true)
		trigger_enable(TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR1,true)
		ingame_effect_add_trigger(TRIGGER_VEHICLEREQUEST_ULTOR1,INGAME_EFFECT_LOCATION)
		on_trigger("enter_request_vehicle_zone",TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR2)
		on_trigger("request_vehicle",TRIGGER_VEHICLEREQUEST_ULTOR2)
		trigger_enable(TRIGGER_VEHICLEREQUEST_ULTOR2,true)
		trigger_enable(TRIGGER_VEHICLE_REQUEST_ZONE_ULTOR2,true)
		ingame_effect_add_trigger(TRIGGER_VEHICLEREQUEST_ULTOR2,INGAME_EFFECT_LOCATION)
	end

end


function enable_playasacop_triggers()
	on_trigger("enter_startcopzone",TRIGGER_STARTZONE)
	on_trigger("enter_startcopzone",TRIGGER_ZONE_ULTOR_1)
	on_trigger("enter_startcopzone",TRIGGER_ZONE_ULTOR_2)
	on_trigger("enter_startcopzone",TRIGGER_ZONE_ULTOR_3)
	on_trigger("enter_startcopzone",TRIGGER_ZONE_ULTOR_4)
	on_trigger("switch_teams",TRIGGER_STARTCOP)
	on_trigger("switch_teams",TRIGGER_START_ULTOR_1)
	on_trigger("switch_teams",TRIGGER_START_ULTOR_2)
	on_trigger("switch_teams",TRIGGER_START_ULTOR_3)
	on_trigger("switch_teams",TRIGGER_START_ULTOR_4)
	trigger_enable(TRIGGER_STARTZONE,true)
	trigger_enable(TRIGGER_ZONE_ULTOR_1,true)
	trigger_enable(TRIGGER_ZONE_ULTOR_2,true)
	trigger_enable(TRIGGER_ZONE_ULTOR_3,true)
	trigger_enable(TRIGGER_ZONE_ULTOR_4,true)
	trigger_enable(TRIGGER_STARTCOP,true)
	trigger_enable(TRIGGER_START_ULTOR_1,true)
	trigger_enable(TRIGGER_START_ULTOR_2,true)
	trigger_enable(TRIGGER_START_ULTOR_3,true)
	trigger_enable(TRIGGER_START_ULTOR_4,true)
	ingame_effect_add_trigger(TRIGGER_STARTCOP,INGAME_EFFECT_LOCATION)
	ingame_effect_add_trigger(TRIGGER_START_ULTOR_1,INGAME_EFFECT_LOCATION)
	ingame_effect_add_trigger(TRIGGER_START_ULTOR_2,INGAME_EFFECT_LOCATION)
	ingame_effect_add_trigger(TRIGGER_START_ULTOR_3,INGAME_EFFECT_LOCATION)
	ingame_effect_add_trigger(TRIGGER_START_ULTOR_4,INGAME_EFFECT_LOCATION)
end


-- Vanilla init

function sr2_city_init()

-- DISTRICTS
	airport_init()
	apartments_init()
	arena_init()
	barrio_init()
	chinatown_init()
	docks_init()
	downtown_init()
	factories_init()
	highend_init()
	hotels_init()
	museum_init()
	nuke_init()
	prison_init()
	projects_init()
	redlight_init()
	saintsrow_init()
	suburbs_init()
	subexp_init()
	trailerpark_init()
	truckyard_init()
	ultor_base_init()
	underground_init()
	university_init()

-- MISSIONS
	mission_globals_init()

-- STRONGHOLDS
	stronghold_globals_init()

end

function sr2_city_main()

-- DISTRICTS
	thread_new("airport_main")
	thread_new("apartments_main")
	thread_new("arena_main")
	thread_new("barrio_main")
	thread_new("chinatown_main")
	thread_new("docks_main")
	thread_new("downtown_main")
	thread_new("factories_main")
	thread_new("highend_main")
	thread_new("hotels_main")
	thread_new("museum_main")
	thread_new("nuke_main")
	thread_new("prison_main")
	thread_new("projects_main")
	thread_new("redlight_main")
	thread_new("saintsrow_main")
	thread_new("suburbs_main")
	thread_new("subexp_main")
	thread_new("trailerpark_main")
	thread_new("truckyard_main")
	thread_new("ultor_base_main")
	thread_new("underground_main")
	thread_new("university_main")

-- MISSIONS
	thread_new("tss01_main")	-- Third Street Saints (Prologue)
	thread_new("tss02_main")
	thread_new("tss03_main")
	thread_new("tss04_main")

	thread_new("bh01_main")		-- The Brotherhood
	thread_new("bh02_main")
	thread_new("bh03_main")
	thread_new("bh04_main")
	thread_new("bh05_main")
	thread_new("bh06_main")
	thread_new("bh07_main")
	thread_new("bh08_main")
	thread_new("bh09_main")
	thread_new("bh10_main")
	thread_new("bh11_main")

	thread_new("rn01_main")		-- The Ronin
	thread_new("rn02_main")
	thread_new("rn03_main")
	thread_new("rn04_main")
	thread_new("rn05_main")
	thread_new("rn06_main")
	thread_new("rn07_main")
	thread_new("rn08_main")
	thread_new("rn09_main")
	thread_new("rn10_main")
	thread_new("rn11_main")

	thread_new("ss01_main")		-- Sons of Samedi
	thread_new("ss02_main")
	thread_new("ss03_main")
	thread_new("ss04_main")
	thread_new("ss05_main")
	thread_new("ss06_main")
	thread_new("ss07_main")
	thread_new("ss08_main")
	thread_new("ss09_main")
	thread_new("ss10_main")
	thread_new("ss11_main")

	thread_new("ep01_main")		-- Epilogue Missions
	thread_new("ep02_main")
	thread_new("ep03_main")
	thread_new("ep04_main")

	thread_new("em01_main")		-- Emergent Missions
	thread_new("em02_main")

-- STRONGHOLDS ???????

	USER_INPUT_THREAD_HANDLE = thread_new("read_user_input")

	-- Enable play as a cop triggers
	enable_playasacop_triggers()

end
